Subject: Re: [patch net-next RFC 0/4] introduce infrastructure for support of switch chip datapath

From: Jamal Hadi Salim <[email-masked]>
Date: Mon, 24 Mar 2014 19:07:35 -0400

On 03/22/14 05:48, Jiri Pirko wrote:
> Fri, Mar 21, 2014 at 01:04:20PM CET, [email-masked] wrote:

> Hmm. This got me thinking about netdev and switches well and perhaps the
> switchdev api could be mostly implemented by couple of more ndos and
> feature flags. That way we could stick to your immortal netdev :)
>
>

Perhaps ;->

>>
>> In my view: that (immortal) device for L2/bridging is the bridge or
>> maybe a more barebone version of the bridge (since it has gained a
>> little more weight in recent times).
>
> Well, I do not think that bridge is ideal abstraction for modern switch
> chips. Bridge is very limited.
>

True - but i was more thinking of being inclusive of the smaller
devices. They are mostly L2 only and in very limited scope. And thats
probably 95% of the population. The things you are talking about
are very high end and they can do more. Florian's taxanomy was useful.

> But I don't necessary think it is needed to "mask" as a bride or mimic a
> bridge in any way. DSA does not do that either.
>

I am open to the idea of exposing ports instead of a bridge.
Such ports could be aggregate together to form a bridge when the
hardware is capable.

> switchdev tries to provide an API. Who takes it and use it is up to us.
> OVS, bridge or whatever.
>

As long as you maintain the current user tools I am happy.
Can i run all my iproute2 tools?

>
> Sure, send us a link please.
>

I will post it somewhere. The starting point was L2; if we decide to
go a different direction it may require a different approach.

cheers,
jamal